diff --git a/doc/src/sgml/maintenance.sgml b/doc/src/sgml/maintenance.sgml
index 4a68ec3b40..888ab22a7d 100644
--- a/doc/src/sgml/maintenance.sgml
+++ b/doc/src/sgml/maintenance.sgml
@@ -108,9 +108,8 @@
      </listitem>
 
      <listitem>
-      <simpara>To protect against loss of very old data due to
-      <firstterm>transaction ID wraparound</firstterm> or
-      <firstterm>multixact ID wraparound</firstterm>.</simpara>
+      <simpara>To shrink <literal>pg_clog</literal> and
+      <literal>pg_multixact</literal>.</simpara>
      </listitem>
     </orderedlist>
 
@@ -376,7 +375,7 @@
   </sect2>
 
   <sect2 id="vacuum-for-wraparound">
-   <title>Preventing Transaction ID Wraparound Failures</title>
+   <title>Forced shrinking <literal>pg_clog</literal> and <literal>pg_multixact</literal></title>
 
    <indexterm zone="vacuum-for-wraparound">
     <primary>transaction ID</primary>
@@ -394,15 +393,30 @@
     depend on being able to compare transaction ID (<acronym>XID</acronym>)
     numbers: a row version with an insertion XID greater than the current
     transaction's XID is <quote>in the future</quote> and should not be visible
-    to the current transaction.  But since transaction IDs have limited size
-    (32 bits) a cluster that runs for a long time (more
+    to the current transaction.  In older versions transaction IDs have
+    limited size (32 bits), and a cluster that runs for a long time (more
     than 4 billion transactions) would suffer <firstterm>transaction ID
     wraparound</firstterm>: the XID counter wraps around to zero, and all of a sudden
     transactions that were in the past appear to be in the future &mdash; which
-    means their output become invisible.  In short, catastrophic data loss.
-    (Actually the data is still there, but that's cold comfort if you cannot
-    get at it.)  To avoid this, it is necessary to vacuum every table
-    in every database at least once every two billion transactions.
+    means data loss as their output become invisible.
+   </para>
+
+   <para>
+    <productname>PostgreSQL</productname> introduced
+    64-bit transaction IDs, which are not subject to wraparound and
+    do not need modulo-2<superscript>32</superscript> arithmetic to be compared.
+    Each tuple header contain two XIDs, so extending them would lead to
+    high overhead.  For that reason on-page XIDs are still 32-bit, but
+    each page's header contains an offset, called <firstterm>epoch</firstterm>,
+    to which they are added before comparing with each other.
+   </para>
+
+   <para>
+    When new xid can't fit existing page according to its <firstterm>epoch</firstterm>,
+    those <firstterm>epoch</firstterm> is shifted.  Single page freeze takes place if
+    needed.  Both actions are performed "on the fly".  Page-level wraparound
+    can happen only when someone holds snapshot which is more than 4 billions
+    transaction oid. 
    </para>
 
    <para>
@@ -411,25 +425,21 @@
     they were inserted by a transaction that committed sufficiently far in
     the past that the effects of the inserting transaction are certain to be
     visible to all current and future transactions.
-    Normal XIDs are
-    compared using modulo-2<superscript>32</superscript> arithmetic. This means
-    that for every normal XID, there are two billion XIDs that are
-    <quote>older</quote> and two billion that are <quote>newer</quote>; another
-    way to say it is that the normal XID space is circular with no
-    endpoint. Therefore, once a row version has been created with a particular
-    normal XID, the row version will appear to be <quote>in the past</quote> for
-    the next two billion transactions, no matter which normal XID we are
-    talking about. If the row version still exists after more than two billion
-    transactions, it will suddenly appear to be in the future. To
-    prevent this, <productname>PostgreSQL</productname> reserves a special XID,
-    <literal>FrozenTransactionId</literal>, which does not follow the normal XID
-    comparison rules and is always considered older
+    <productname>PostgreSQL</productname> reserves a special XID,
+    <literal>FrozenTransactionId</literal>, which is always considered older
     than every normal XID.
     Frozen row versions are treated as if the inserting XID were
     <literal>FrozenTransactionId</literal>, so that they will appear to be
-    <quote>in the past</quote> to all normal transactions regardless of wraparound
-    issues, and so such row versions will be valid until deleted, no matter
-    how long that is.
+    <quote>in the past</quote> to all normal transactions.
+   </para>
+
+   <para>
+    Freezing data by <command>VACUUM</command> is not needed anymore for preventing
+    wraparound, since page-level freeze happens "on the fly".  However,
+    freezing data by <command>VACUUM</command> is still needed for shrink
+    <literal>pg_clog</literal> and <literal>pg_multixact</literal>.  For historical reasons,
+    wording "autovacuum to prevent wraparound" is preserved for forced
+    atuvacuum for shrink <literal>pg_clog</literal> and <literal>pg_multixact</literal>.
    </para>
 
    <note>
@@ -481,12 +491,7 @@
    </para>
 
    <para>
-    The maximum time that a table can go unvacuumed is two billion
-    transactions minus the <varname>vacuum_freeze_min_age</varname> value at
-    the time of the last aggressive vacuum. If it were to go
-    unvacuumed for longer than
-    that, data loss could result.  To ensure that this does not happen,
-    autovacuum is invoked on any table that might contain unfrozen rows with
+    Autovacuum is invoked on any table that might contain unfrozen rows with
     XIDs older than the age specified by the configuration parameter <xref
     linkend="guc-autovacuum-freeze-max-age"/>.  (This will happen even if
     autovacuum is disabled.)
@@ -512,14 +517,16 @@
     <varname>autovacuum_freeze_max_age</varname>; a setting higher than that will be
     capped to the maximum. A value higher than
     <varname>autovacuum_freeze_max_age</varname> wouldn't make sense because an
-    anti-wraparound autovacuum would be triggered at that point anyway, and
+    autovacuum to shrink <literal>pg_clog</literal> and <literal>pg_multixact</literal>
+    would be triggered at that point anyway, and
     the 0.95 multiplier leaves some breathing room to run a manual
     <command>VACUUM</command> before that happens.  As a rule of thumb,
     <command>vacuum_freeze_table_age</command> should be set to a value somewhat
     below <varname>autovacuum_freeze_max_age</varname>, leaving enough gap so that
     a regularly scheduled <command>VACUUM</command> or an autovacuum triggered by
     normal delete and update activity is run in that window.  Setting it too
-    close could lead to anti-wraparound autovacuums, even though the table
+    close could lead to autovacuums to to shrink <literal>pg_clog</literal> and
+    <literal>pg_multixact</literal>, even though the table
     was recently vacuumed to reclaim space, whereas lower values lead to more
     frequent aggressive vacuuming.
    </para>
@@ -605,43 +612,8 @@ SELECT datname, age(datfrozenxid) FROM pg_database;
     be forced for the table.
    </para>
 
-   <para>
-    If for some reason autovacuum fails to clear old XIDs from a table,
-    the system will begin to emit warning messages like this when the
-    database's oldest XIDs reach ten million transactions from the wraparound
-    point:
-
-<programlisting>
-WARNING:  database "mydb" must be vacuumed within 177009986 transactions
-HINT:  To avoid a database shutdown, execute a database-wide VACUUM in "mydb".
-</programlisting>
-
-    (A manual <command>VACUUM</command> should fix the problem, as suggested by the
-    hint; but note that the <command>VACUUM</command> must be performed by a
-    superuser, else it will fail to process system catalogs and thus not
-    be able to advance the database's <structfield>datfrozenxid</structfield>.)
-    If these warnings are
-    ignored, the system will shut down and refuse to start any new
-    transactions once there are fewer than 1 million transactions left
-    until wraparound:
-
-<programlisting>
-ERROR:  database is not accepting commands to avoid wraparound data loss in database "mydb"
-HINT:  Stop the postmaster and vacuum that database in single-user mode.
-</programlisting>
-
-    The 1-million-transaction safety margin exists to let the
-    administrator recover without data loss, by manually executing the
-    required <command>VACUUM</command> commands.  However, since the system will not
-    execute commands once it has gone into the safety shutdown mode,
-    the only way to do this is to stop the server and start the server in single-user
-    mode to execute <command>VACUUM</command>.  The shutdown mode is not enforced
-    in single-user mode.  See the <xref linkend="app-postgres"/> reference
-    page for details about using single-user mode.
-   </para>
-
    <sect3 id="vacuum-for-multixact-wraparound">
-    <title>Multixacts and Wraparound</title>
+    <title>Shrinking <literal>pg_multixact</literal></title>
 
     <indexterm>
      <primary>MultiXactId</primary>
@@ -662,12 +634,12 @@ HINT:  Stop the postmaster and vacuum that database in single-user mode.
      particular multixact ID is stored separately in
      the <filename>pg_multixact</filename> subdirectory, and only the multixact ID
      appears in the <structfield>xmax</structfield> field in the tuple header.
-     Like transaction IDs, multixact IDs are implemented as a
-     32-bit counter and corresponding storage, all of which requires
-     careful aging management, storage cleanup, and wraparound handling.
+     Like transaction IDs, multixact IDs are implemented on disk page as a
+     64-bit counter with an offset relative to epoch, and corresponding storage,
+     which requires
+     careful aging management, and storage cleanup.
      There is a separate storage area which holds the list of members in
-     each multixact, which also uses a 32-bit counter and which must also
-     be managed.
+     each multixact, which uses a 64-bit counter.
     </para>
 
     <para>
@@ -695,14 +667,9 @@ HINT:  Stop the postmaster and vacuum that database in single-user mode.
     </para>
 
     <para>
-     As a safety device, an aggressive vacuum scan will occur for any table
+     An aggressive vacuum scan will occur for any table
      whose multixact-age is greater than
-     <xref linkend="guc-autovacuum-multixact-freeze-max-age"/>.  Aggressive
-     vacuum scans will also occur progressively for all tables, starting with
-     those that have the oldest multixact-age, if the amount of used member
-     storage space exceeds the amount 50% of the addressable storage space.
-     Both of these kinds of aggressive scans will occur even if autovacuum is
-     nominally disabled.
+     <xref linkend="guc-autovacuum-multixact-freeze-max-age"/>.
     </para>
    </sect3>
   </sect2>
@@ -715,7 +682,7 @@ HINT:  Stop the postmaster and vacuum that database in single-user mode.
     <secondary>general information</secondary>
    </indexterm>
    <para>
-    <productname>PostgreSQL</productname> has an optional but highly
+    <productname>PostgreSQL 11</productname> has an optional but highly
     recommended feature called <firstterm>autovacuum</firstterm>,
     whose purpose is to automate the execution of
     <command>VACUUM</command> and <command>ANALYZE </command> commands.
diff --git a/doc/src/sgml/ref/create_table.sgml b/doc/src/sgml/ref/create_table.sgml
index a0c9a6d257..5fc86f9a2a 100644
--- a/doc/src/sgml/ref/create_table.sgml
+++ b/doc/src/sgml/ref/create_table.sgml
@@ -1242,11 +1242,12 @@ WITH ( MODULUS <replaceable class="parameter">numeric_literal</replaceable>, REM
      If true, the autovacuum daemon will perform automatic <command>VACUUM</command>
      and/or <command>ANALYZE</command> operations on this table following the rules
      discussed in <xref linkend="autovacuum"/>.
-     If false, this table will not be autovacuumed, except to prevent
-     transaction ID wraparound. See <xref linkend="vacuum-for-wraparound"/> for
-     more about wraparound prevention.
-     Note that the autovacuum daemon does not run at all (except to prevent
-     transaction ID wraparound) if the <xref linkend="guc-autovacuum"/>
+     If false, this table will not be autovacuumed, except to shrink
+     <literal>pg_clog</literal> and <literal>pg_multixact</literal>.
+     See <xref linkend="vacuum-for-wraparound"/> for more about that.
+     Note that the autovacuum daemon does not run at all (except to shrink
+     <literal>pg_clog</literal> and <literal>pg_multixact</literal>) if the
+     <xref linkend="guc-autovacuum"/>
      parameter is false; setting individual tables' storage parameters does
      not override that.  Therefore there is seldom much point in explicitly
      setting this storage parameter to <literal>true</literal>, only
diff --git a/doc/src/sgml/ref/prepare_transaction.sgml b/doc/src/sgml/ref/prepare_transaction.sgml
index d958f7a06f..26702802d7 100644
--- a/doc/src/sgml/ref/prepare_transaction.sgml
+++ b/doc/src/sgml/ref/prepare_transaction.sgml
@@ -126,9 +126,7 @@ PREPARE TRANSACTION <replaceable class="parameter">transaction_id</replaceable>
    <para>
     It is unwise to leave transactions in the prepared state for a long time.
     This will interfere with the ability of <command>VACUUM</command> to reclaim
-    storage, and in extreme cases could cause the database to shut down
-    to prevent transaction ID wraparound (see <xref
-    linkend="vacuum-for-wraparound"/>).  Keep in mind also that the transaction
+    storage.  Keep in mind also that the transaction
     continues to hold whatever locks it held.  The intended usage of the
     feature is that a prepared transaction will normally be committed or
     rolled back as soon as an external transaction manager has verified that
diff --git a/doc/src/sgml/storage.sgml b/doc/src/sgml/storage.sgml
index c0e548fa5b..91fe806c9f 100644
--- a/doc/src/sgml/storage.sgml
+++ b/doc/src/sgml/storage.sgml
@@ -651,7 +651,6 @@ This information can also be used
 by <link linkend="indexes-index-only-scans"><firstterm>index-only
 scans</firstterm></link> to answer queries using only the index tuple.
 The second bit, if set, means that all tuples on the page have been frozen.
-That means that even an anti-wraparound vacuum need not revisit the page.
 </para>
 
 <para>
@@ -777,7 +776,7 @@ data. Empty in ordinary tables.</entry>
 
  <para>
 
-  The first 24 bytes of each page consists of a page header
+  The first 40 bytes of each page consists of a page header
   (<structname>PageHeaderData</structname>). Its format is detailed in <xref
   linkend="pageheaderdata-table"/>. The first field tracks the most
   recent WAL entry related to this page. The second field contains
@@ -787,7 +786,9 @@ data. Empty in ordinary tables.</entry>
   <structfield>pd_upper</structfield>, and
   <structfield>pd_special</structfield>).  These contain byte offsets
   from the page start to the start of unallocated space, to the end of
-  unallocated space, and to the start of the special space.  The next 2
+  unallocated space, and to the start of the special space.
+  Next are two 8-byte fields containing base, i. e. an offset, for
+  short (4-byte) transacion IDs in this page. The next 2
   bytes of the page header, <structfield>pd_pagesize_version</structfield>,
   store both the page size and a version indicator.  Beginning with
   <productname>PostgreSQL</productname> 8.3 the version number is 4;
@@ -861,8 +862,20 @@ data. Empty in ordinary tables.</entry>
    <entry>Page size and layout version number information</entry>
   </row>
   <row>
-   <entry>pd_prune_xid</entry>
+   <entry>pd_xid_base</entry>
+   <entry>TransactionId</entry>
+   <entry>8 bytes</entry>
+   <entry>Base for short 4-byte transaction IDs in this page</entry>
+  </row>
+  <row>
+   <entry>pd_multi_base</entry>
    <entry>TransactionId</entry>
+   <entry>8 bytes</entry>
+   <entry>Base for short 4-byte multixact IDs in this page</entry>
+  </row>
+  <row>
+   <entry>pd_prune_xid</entry>
+   <entry>ShortTransactionId</entry>
    <entry>4 bytes</entry>
    <entry>Oldest unpruned XMAX on page, or zero if none</entry>
   </row>
@@ -920,7 +933,7 @@ data. Empty in ordinary tables.</entry>
  <para>
 
   All table rows are structured in the same way. There is a fixed-size
-  header (occupying 23 bytes on most machines), followed by an optional null
+  header (occupying 40 bytes on most machines), followed by an optional null
   bitmap, an optional object ID field, and the user data. The header is
   detailed
   in <xref linkend="heaptupleheaderdata-table"/>.  The actual user data
@@ -958,13 +971,13 @@ data. Empty in ordinary tables.</entry>
  <tbody>
   <row>
    <entry>t_xmin</entry>
-   <entry>TransactionId</entry>
+   <entry>ShortTransactionId</entry>
    <entry>4 bytes</entry>
    <entry>insert XID stamp</entry>
   </row>
   <row>
    <entry>t_xmax</entry>
-   <entry>TransactionId</entry>
+   <entry>ShortTransactionId</entry>
    <entry>4 bytes</entry>
    <entry>delete XID stamp</entry>
   </row>
@@ -976,7 +989,7 @@ data. Empty in ordinary tables.</entry>
   </row>
   <row>
    <entry>t_xvac</entry>
-   <entry>TransactionId</entry>
+   <entry>ShortTransactionId</entry>
    <entry>4 bytes</entry>
    <entry>XID for VACUUM operation moving a row version</entry>
   </row>
diff --git a/src/backend/access/common/heaptuple.c b/src/backend/access/common/heaptuple.c
index 0a13251067..28c45a5bdb 100644
--- a/src/backend/access/common/heaptuple.c
+++ b/src/backend/access/common/heaptuple.c
@@ -571,10 +571,10 @@ heap_getsysattr(HeapTuple tup, int attnum, TupleDesc tupleDesc, bool *isnull)
 			result = ObjectIdGetDatum(HeapTupleGetOid(tup));
 			break;
 		case MinTransactionIdAttributeNumber:
-			result = TransactionIdGetDatum(HeapTupleHeaderGetRawXmin(tup->t_data));
+			result = TransactionIdGetDatum(HeapTupleGetRawXmin(tup));
 			break;
 		case MaxTransactionIdAttributeNumber:
-			result = TransactionIdGetDatum(HeapTupleHeaderGetRawXmax(tup->t_data));
+			result = TransactionIdGetDatum(HeapTupleGetRawXmax(tup));
 			break;
 		case MinCommandIdAttributeNumber:
 		case MaxCommandIdAttributeNumber:
@@ -619,6 +619,7 @@ heap_copytuple(HeapTuple tuple)
 	newTuple->t_len = tuple->t_len;
 	newTuple->t_self = tuple->t_self;
 	newTuple->t_tableOid = tuple->t_tableOid;
+	HeapTupleCopyBase(newTuple, tuple);
 	newTuple->t_data = (HeapTupleHeader) ((char *) newTuple + HEAPTUPLESIZE);
 	memcpy((char *) newTuple->t_data, (char *) tuple->t_data, tuple->t_len);
 	return newTuple;
@@ -645,6 +646,7 @@ heap_copytuple_with_tuple(HeapTuple src, HeapTuple dest)
 	dest->t_len = src->t_len;
 	dest->t_self = src->t_self;
 	dest->t_tableOid = src->t_tableOid;
+	HeapTupleCopyBase(dest, src);
 	dest->t_data = (HeapTupleHeader) palloc(src->t_len);
 	memcpy((char *) dest->t_data, (char *) src->t_data, src->t_len);
 }
@@ -755,6 +757,7 @@ heap_form_tuple(TupleDesc tupleDescriptor,
 	tuple->t_len = len;
 	ItemPointerSetInvalid(&(tuple->t_self));
 	tuple->t_tableOid = InvalidOid;
+	HeapTupleSetZeroBase(tuple);
 
 	HeapTupleHeaderSetDatumLength(td, len);
 	HeapTupleHeaderSetTypeId(td, tupleDescriptor->tdtypeid);
@@ -843,6 +846,7 @@ heap_modify_tuple(HeapTuple tuple,
 	newTuple->t_data->t_ctid = tuple->t_data->t_ctid;
 	newTuple->t_self = tuple->t_self;
 	newTuple->t_tableOid = tuple->t_tableOid;
+	HeapTupleCopyBase(newTuple, tuple);
 	if (tupleDesc->tdhasoid)
 		HeapTupleSetOid(newTuple, HeapTupleGetOid(tuple));
 
@@ -1505,6 +1509,7 @@ heap_tuple_from_minimal_tuple(MinimalTuple mtup)
 	result->t_len = len;
 	ItemPointerSetInvalid(&(result->t_self));
 	result->t_tableOid = InvalidOid;
+	HeapTupleSetZeroBase(result);
 	result->t_data = (HeapTupleHeader) ((char *) result + HEAPTUPLESIZE);
 	memcpy((char *) result->t_data + MINIMAL_TUPLE_OFFSET, mtup, mtup->t_len);
 	memset(result->t_data, 0, offsetof(HeapTupleHeaderData, t_infomask2));
diff --git a/src/backend/access/common/reloptions.c b/src/backend/access/common/reloptions.c
index 9289b642a4..2c48e59c90 100644
--- a/src/backend/access/common/reloptions.c
+++ b/src/backend/access/common/reloptions.c
@@ -230,58 +230,6 @@ static relopt_int intRelOpts[] =
 		},
 		-1, 1, 10000
 	},
-	{
-		{
-			"autovacuum_freeze_min_age",
-			"Minimum age at which VACUUM should freeze a table row, for autovacuum",
-			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
-			ShareUpdateExclusiveLock
-		},
-		-1, 0, 1000000000
-	},
-	{
-		{
-			"autovacuum_multixact_freeze_min_age",
-			"Minimum multixact age at which VACUUM should freeze a row multixact's, for autovacuum",
-			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
-			ShareUpdateExclusiveLock
-		},
-		-1, 0, 1000000000
-	},
-	{
-		{
-			"autovacuum_freeze_max_age",
-			"Age at which to autovacuum a table to prevent transaction ID wraparound",
-			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
-			ShareUpdateExclusiveLock
-		},
-		-1, 100000, 2000000000
-	},
-	{
-		{
-			"autovacuum_multixact_freeze_max_age",
-			"Multixact age at which to autovacuum a table to prevent multixact wraparound",
-			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
-			ShareUpdateExclusiveLock
-		},
-		-1, 10000, 2000000000
-	},
-	{
-		{
-			"autovacuum_freeze_table_age",
-			"Age at which VACUUM should perform a full table sweep to freeze row versions",
-			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
-			ShareUpdateExclusiveLock
-		}, -1, 0, 2000000000
-	},
-	{
-		{
-			"autovacuum_multixact_freeze_table_age",
-			"Age of multixact at which VACUUM should perform a full table sweep to freeze row versions",
-			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
-			ShareUpdateExclusiveLock
-		}, -1, 0, 2000000000
-	},
 	{
 		{
 			"log_autovacuum_min_duration",
@@ -339,19 +287,70 @@ static relopt_int intRelOpts[] =
 		},
 		-1, 0, 1024
 	},
-
 	/* list terminator */
 	{{NULL}}
 };
 
-
 static relopt_int64 int64RelOpts[] =
 {
+	{
+		{
+			"autovacuum_freeze_min_age",
+			"Minimum age at which VACUUM should freeze a table row, for autovacuum",
+			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+			ShareUpdateExclusiveLock
+		},
+		INT64CONST(-1), INT64CONST(0), INT64CONST(1000000000)
+	},
+	{
+		{
+			"autovacuum_multixact_freeze_min_age",
+			"Minimum multixact age at which VACUUM should freeze a row multixact's, for autovacuum",
+			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+			ShareUpdateExclusiveLock
+		},
+		INT64CONST(-1), INT64CONST(0), INT64CONST(1000000000)
+	},
+	{
+		{
+			"autovacuum_freeze_max_age",
+			"Age at which to autovacuum a table to prevent transaction ID wraparound",
+			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+			ShareUpdateExclusiveLock
+		},
+		INT64CONST(-1), INT64CONST(100000), INT64CONST(2000000000)
+	},
+	{
+		{
+			"autovacuum_multixact_freeze_max_age",
+			"Multixact age at which to autovacuum a table to prevent multixact wraparound",
+			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+			ShareUpdateExclusiveLock
+		},
+		INT64CONST(-1), INT64CONST(10000), INT64CONST(2000000000)
+	},
+	{
+		{
+			"autovacuum_freeze_table_age",
+			"Age at which VACUUM should perform a full table sweep to freeze row versions",
+			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+			ShareUpdateExclusiveLock
+		},
+		INT64CONST(-1), INT64CONST(0), INT64CONST(2000000000)
+	},
+	{
+		{
+			"autovacuum_multixact_freeze_table_age",
+			"Age of multixact at which VACUUM should perform a full table sweep to freeze row versions",
+			RELOPT_KIND_HEAP | RELOPT_KIND_TOAST,
+			ShareUpdateExclusiveLock
+		},
+		INT64CONST(-1), INT64CONST(0), INT64CONST(2000000000)
+	},
 	/* list terminator */
 	{{NULL}}
 };
 
-
 static relopt_real realRelOpts[] =
 {
 	{
@@ -484,6 +483,12 @@ initialize_reloptions(void)
 								   int64RelOpts[i].gen.lockmode));
 		j++;
 	}
+	for (i = 0; int64RelOpts[i].gen.name; i++)
+	{
+		Assert(DoLockModesConflict(int64RelOpts[i].gen.lockmode,
+								   int64RelOpts[i].gen.lockmode));
+		j++;
+	}
 	for (i = 0; realRelOpts[i].gen.name; i++)
 	{
 		Assert(DoLockModesConflict(realRelOpts[i].gen.lockmode,
@@ -1410,17 +1415,17 @@ default_reloptions(Datum reloptions, bool validate, relopt_kind kind)
 		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_cost_delay)},
 		{"autovacuum_vacuum_cost_limit", RELOPT_TYPE_INT,
 		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, vacuum_cost_limit)},
-		{"autovacuum_freeze_min_age", RELOPT_TYPE_INT,
+		{"autovacuum_freeze_min_age", RELOPT_TYPE_INT64,
 		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, freeze_min_age)},
-		{"autovacuum_freeze_max_age", RELOPT_TYPE_INT,
+		{"autovacuum_freeze_max_age", RELOPT_TYPE_INT64,
 		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, freeze_max_age)},
-		{"autovacuum_freeze_table_age", RELOPT_TYPE_INT,
+		{"autovacuum_freeze_table_age", RELOPT_TYPE_INT64,
 		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, freeze_table_age)},
-		{"autovacuum_multixact_freeze_min_age", RELOPT_TYPE_INT,
+		{"autovacuum_multixact_freeze_min_age", RELOPT_TYPE_INT64,
 		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, multixact_freeze_min_age)},
-		{"autovacuum_multixact_freeze_max_age", RELOPT_TYPE_INT,
+		{"autovacuum_multixact_freeze_max_age", RELOPT_TYPE_INT64,
 		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, multixact_freeze_max_age)},
-		{"autovacuum_multixact_freeze_table_age", RELOPT_TYPE_INT,
+		{"autovacuum_multixact_freeze_table_age", RELOPT_TYPE_INT64,
 		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, multixact_freeze_table_age)},
 		{"log_autovacuum_min_duration", RELOPT_TYPE_INT,
 		offsetof(StdRdOptions, autovacuum) + offsetof(AutoVacOpts, log_min_duration)},
diff --git a/src/backend/access/hash/hash_xlog.c b/src/backend/access/hash/hash_xlog.c
index b38208e61d..6da06dbdbe 100644
--- a/src/backend/access/hash/hash_xlog.c
+++ b/src/backend/access/hash/hash_xlog.c
@@ -18,6 +18,7 @@
 #include "access/bufmask.h"
 #include "access/hash.h"
 #include "access/hash_xlog.h"
+#include "access/htup_details.h"
 #include "access/xlogutils.h"
 #include "access/xlog.h"
 #include "access/transam.h"
@@ -988,7 +989,6 @@ hash_xlog_vacuum_get_latestRemovedXid(XLogReaderState *record)
 	ItemId		iitemid,
 				hitemid;
 	IndexTuple	itup;
-	HeapTupleHeader htuphdr;
 	BlockNumber hblkno;
 	OffsetNumber hoffnum;
 	TransactionId latestRemovedXid = InvalidTransactionId;
@@ -1088,8 +1088,12 @@ hash_xlog_vacuum_get_latestRemovedXid(XLogReaderState *record)
 		 */
 		if (ItemIdHasStorage(hitemid))
 		{
-			htuphdr = (HeapTupleHeader) PageGetItem(hpage, hitemid);
-			HeapTupleHeaderAdvanceLatestRemovedXid(htuphdr, &latestRemovedXid);
+			HeapTupleData htup;
+
+			htup.t_data = (HeapTupleHeader) PageGetItem(hpage, hitemid);
+			HeapTupleCopyBaseFromPage(&htup, hpage);
+
+			HeapTupleHeaderAdvanceLatestRemovedXid(&htup, &latestRemovedXid);
 		}
 		else if (ItemIdIsDead(hitemid))
 		{
